/***************************************************
 *
 *  TYPE Declaration
 *
 ***************************************************/

struct trie { /* trie of clauses */
  char psign, esign; 
  SATOINT key;
  struct trie *bro;
  struct trie *pos, *neg;
  struct trie *par;
  struct links *link;
};

struct links {
  struct trie *lin;
  struct trie *back;
  struct cap *stamp;
};

struct cap { 
  struct trie *tr;
};

struct var3 { 
  int key;
  struct trie *push, *pull;
  struct trie **pos, **neg;
  struct cap *both, *poss, *negs;
  struct cap *pposs, *pnegs;
  struct var3 *next;
};

struct var2 { 
  SATOINT key;
  SATOINT pos_extra;
  SATOINT neg_extra;
  SATOINT level;
  SATOINT pos2;
  SATOINT neg2;
  int pure;
  int pos_count;
  int neg_count;
  struct trie *frozen, *force;
  struct trie **pos, **neg;
  struct var2 *next;
};

/**********************
  MACROS
***********************/
#define HAS_POS_CL(no) (no->pos == CLAUSE3)
#define HAS_NEG_CL(no) (no->neg == CLAUSE3)

#define trie2_propagate(a,b,c) \
  ((b)? trie2_propagate_true(a,c) : trie2_propagate_false(a,c))

#define count_of_clause(cl) cl->key
#define active_clause(cl) cl->neg == NULL
#define frozen_lin(cl) cl->neg

#define binary_lin(cl) cl->pos
#define unit_lin(cl) cl->link->back

#define level_of(it) it->level
#define mark_of(it) it->force
#define frozen_cls(it) it->frozen

#define free_trie_cell(no) \
  if (no->key == -1) { \
     printf("re-free a cell\n"); bug(4);\
  } else { no->key = -1; \
    no->bro = Trie_avail; \
    Trie_avail = no;\
    Trie_avails++; \
  }\
  Trie_frees++
	 
/**********************
  VARIABLES
***********************/

